<'
import demo_ahb_config;
import macro;

type unique_mstr_name_t :[];
type unique_slave_name_t :[];
extend  vr_ahb_agent_monitor {
	get_unique_master_name(): unique_mstr_name_t is empty;
	get_unique_slave_name(): unique_slave_name_t is empty;
};
extend vr_ahb_master{
	keep has_coverage;
};
extend vr_ahb_slave{
	keep has_coverage;
};

extend has_coverage MASTER vr_ahb_agent_monitor {
	cover burst_ended_master_cover is also {
		item master_name using also no_collect, per_instance=FALSE;
		item unique_name: unique_mstr_name_t= get_unique_master_name() using per_instance;
	};
	cover tr_ended_master_cover is also {
		item master_name using also no_collect, per_instance=FALSE;
		item unique_name: unique_mstr_name_t= get_unique_master_name() using per_instance;
	};
	cover transaction_ended_master_cover is also {
		item master_name using also no_collect, per_instance=FALSE;
		item unique_name: unique_mstr_name_t= get_unique_master_name() using per_instance;
	};
};
extend has_coverage SLAVE vr_ahb_agent_monitor {
	cover burst_ended_slave_cover is also {
		item slave_name using also no_collect, per_instance=FALSE;
		item unique_name: unique_slave_name_t= get_unique_slave_name() using per_instance;
	};
	cover tr_ended_slave_cover is also {
		item slave_name using also no_collect, per_instance=FALSE;
		item unique_name: unique_slave_name_t= get_unique_slave_name() using per_instance;
	};
};

ARM9_DAHB_0 slaves == {S0; S1; S2};
ARM9_DAHB_0 masters == {M0; M1; M2};

'>
