<'

define <per_inst_master_macro'statement> "<env'name> masters == <block>" as computed {
	var x : list of string;
	var blk : string = str_expand_dots(<2>.as_a(string));
	var mstrs : list of string = str_split( blk, "/[;{}]/");
	-- This is to remove '{}' from the string
	if not mstrs.is_empty() {
		compute mstrs.pop0();
		compute mstrs.pop();
	};
	x.add("{"); 
	for each (l) in mstrs {
		x.add(append("extend unique_mstr_name_t : [", <1>, "_", l, "];"));
	};
	x.add(append("extend  ", <1>, " vr_ahb_agent_monitor { \
		get_unique_master_name(): unique_mstr_name_t is also {"));
	for each (n) in mstrs {
		x.add(append("if (master_name==", n, ") { return(", <1>, "_", n, ");};"));
	};
	x.add("};};");
	x.add("}");
	return str_join(x,"");
};

define <per_inst_slave_macro'statement> "<env'name> slaves == <block>" as computed {
	var x : list of string;
	var blk : string = str_expand_dots(<2>.as_a(string));
	var slaves : list of string = str_split( blk, "/[;{}]/");
	-- This is to remove '{}' from the string
	if not slaves.is_empty() {
		compute slaves.pop0();
		compute slaves.pop();
	};
	x.add("{"); 
	for each (u) in slaves {
		x.add(append("extend unique_slave_name_t : [", <1>, "_", u, "];"));
	};
	x.add(append("extend  ", <1>, " SLAVE vr_ahb_agent_monitor { \
		get_unique_slave_name(): unique_slave_name_t is also {"));
	for each (v) in slaves {
		x.add(append("if (slave_name==", v, ") { return(", <1>, "_", v, ");};"));
	};
	x.add("};};");
	x.add("}");
	return str_join(x,"");
};
'>
